# Flaskritol - Cómo encaja todo junto

Para comprender cómo trabajar con PHP, Apache y MySQL, es útil saber cómo interactúan entre sí y el papel que desempeñan para brindar una mayor potencia de procesamiento de datos a las [películas Flash](https://www.stockbitcoin.info/es/dontorrent-alternativas/). Como se señaló anteriormente, las películas Flash suelen ser independientes. Se envía una única solicitud desde un navegador web al servidor remoto, lo que hace que la película SWF se descargue en el equipo cliente. A partir de entonces, toda la interacción entre el usuario y la película Flash se lleva a cabo localmente en la computadora del usuaro.

Normalmente, las únicas veces que se realizan más solicitudes al servidor remoto es cuando se cargan otras películas, imágenes o activos predeterminados en la película principal.

# Cliente y Servidor

Las palabras cliente y servidor tienden a difundirse mucho cuando se habla de bases de datos y tecnologías como PHP. Un servidor puede significar una computadora o un programa en una computadora que responde a las solicitudes de los clientes (o usuarios). Por ejemplo, es muy probable que su sitio web esté alojado en una computadora remota conocida como servidor. En esa computadora se ejecutará un servidor web, un programa, como Apache, que envía archivos web a cualquier computadora cliente que los solicite. Para poder trabajar con bases de datos, también necesita un servidor de base de datos, que es otro programa que responde a las solicitudes para almacenar o recuperar información de la base de datos. Para fines de desarrollo, es normal instalar un servidor web y un servidor de base de datos en su computadora local. Estos son simplemente programas que se instalan como cualquier otro, y no implican la necesidad de comprar ningún hardware adicional.

Cuando agrega PHP a la ecuación, lo que sucede depende de lo que quiera hacer. En muchos casos, las películas Flash se descargará exactamente de la misma manera. No hay interacción con PHP hasta que el usuario activa un evento que llama a un script PHP. Este es el caso de la aplicación que creará en el siguiente capítulo: un formulario de comentarios que usa PHP para formatear la entrada del usuario y enviarlo por correo electrónico a su buzón. Si el usuario decide no usar el formulario, nunca se llamará al script PHP. En otros casos, la película Flash llama a un script PHP tan pronto como se carga en la computadora cliente, y lo que aparece en la pantalla está determinado por el resultado de ese script. Por ejemplo, es probable que los titulares de un sitio de noticias se extraigan de una base de datos y sean diferentes cada vez que alguien visite el sitio. En otras ocasiones, el contenido cambiante depende de la entrada del usuario, como ocurre con el motor de búsqueda.
          
## Pasos de instalación 
               
1. La computadora cliente envía una solicitud al servidor web (normalmente Apache).
2. El servidor entrega la película Flash.
3. Si la película Flash envía una solicitud a un script PHP (ya sea automáticamente a través de ActionScript cuando se carga inicialmente o en respuesta a la interacción del usuario), el servidor web pasa el script al motor PHP para su análisis.
4. Si el script PHP inicia una consulta a la base de datos, se envía una solicitud al servidor MySQL.
5. Los resultados de la consulta de la base de datos se envían al motor PHP para su procesamiento.
6. El servidor web envía los datos procesadosdel cliente.
7. La película Flash reacciona de acuerdo con los datos recibidos

Están sucediendo muchas cosas y este proceso se puede repetir muchas veces a medida que el usuario interactúa con la película. A veces, se requieren las siete etapas de este proceso. En otras ocasiones, PHP puede simplemente hacer todo el procesamiento por sí mismo sin tener que consultar la base de datos. Aunque suene complicado, PHP, MySQL y Apache pueden buscar en muchos miles de registros en una fracción de segundo, por lo que el usuario puede no darse cuenta de nada que esté sucediendo en segundo plano. El mayor retraso suele deberse a una conexión lenta a Internet o a cuellos de botella en la red. 
